config/routes.rb
# encoding: utf-8
class CourseConstraint
  def matches?(request)
    params = request.path_parameters
    tmp_course = Course.find(params[:id])
    return false if params[:course] != tmp_course.course.parameterize('_')
    true
  end  
end

class MediaConstraint
  def matches?(request)
    obj = request.fullpath.include?('media') ? Media : Audio
    params = request.path_parameters
    tmp = obj.find(params[:id])
    return false if params[:end_date] != tmp.end_date
    true
  end  
end
  
Rails.application.routes.draw do
  root 'welcome#index'
  get 'welcome/index'
  get '/ruby-version' => 'application#ruby_version'
  resources :media do
   collection do
     get 'search', to: 'media#search'
   end 
  end
  resources :audios do
   collection do
     get 'search', to: 'audios#search'
   end 
  end  
  resources :courses do
   collection do
     post 'add_to_course', to: 'courses#add_to_course'
     get 'search', to: 'courses#search'
     get 'clone_course', to: 'courses#clone_course'
     get 'send_email', to: 'courses#send_email'
     get 'archive', to: 'courses#archive'
     get 'archive_search', to: 'courses#archive_search'
     get 'lookup', to: 'courses#lookup'
     get 'unarchive', to: 'courses#unarchive'
     get 'sort', to: 'courses#sort'
   end
  end
  resources :analytics
  resources :licensed_analytics
    
  get 'media/:id/:ds', :to => 'file#show', :constraints => { :ds => /[^\/]+/ }, :as => 'file'  
  get 'courses/:id/:quarter/:year/:course', :to => 'courses#show', constraints: CourseConstraint.new, :as => :course_report
  get 'media/:id/:end_date/:file_name', :to => 'media#view', constraints: MediaConstraint.new, :as => 'video_view'
  get 'audios/:id/:end_date/:file_name', :to => 'audios#view', constraints: MediaConstraint.new, :as => 'audio_view'

  get '/auth/shibboleth', as: :shibboleth
  get '/auth/developer', to: 'users/sessions#developer', as: :developer
  match '/auth/shibboleth/callback' => 'users/sessions#shibboleth', as: :callback, via: [:get, :post]
  get '/users/sign_in', :to => 'users/sessions#new', :as => :new_user_session
  get '/users/sign_out', :to => 'users/sessions#destroy', :as => :destroy_user_session

  # Log out
  get 'logout', :to => 'welcome#logout', as: :logout

  match '*a', :to => 'errors#routing', via: [:get]
end

app/views/shared/_display_bottom_paginate.html.erb
<div class="text-center">
  <%= paginate obj %>
</div>

app/views/shared/_display_paginate.html.erb
<div class="text-center">
  <%= page_entries_info obj %><br/>
  <%= paginate obj %>
</div>

app/views/shared/_error_messages.html.erb
<% if obj.errors.any? %>
     <div id="error_explanation">
      <h2><%= pluralize(obj.errors.count, "error") %> prohibited this record from being saved:</h2>

      <ul>
      <% obj.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
<% end %>

app/views/shared/_flash_messages.html.erb
<% if flash.any? %>
  <div class="alert alert-alert alert-success">
    <button type="button" class="close" data-dismiss="alert">&#215;</button>
    <% flash.each do |name, msg| %>
      <div id="flash_<%= name %>"><%= msg %></div> 
    <% end %>
  </div>
<% end %>

app/views/shared/_footer.html.erb
<footer>
	<section id="footer">
		<address>
			<strong>UC San Diego</strong>
			9500 Gilman Dr.
			La Jolla, CA 92093
			(858) 534-2230
		</address>
		<p>Copyright © 2015 Regents of the University of California. All rights reserved.</p>
		<ul class="inline">
			<li><a href="http://www.ucsd.edu/_about/legal/index.html">Terms &amp; Conditions</a></li>
			<li class="muted">|</li>
			<li><a href="#">Feedback</a></li>
			<li class="muted">|</li>
		  <li><a href="https://libraries.ucsd.edu/">Library Home</a></li>
		</ul>
	</section>
</footer>

app/views/shared/_head.html.erb
<head>
  <title>DMR</title>
  <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => true %>
  <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
  <script src="https://content.jwplatform.com/libraries/uS59kPRL.js"></script>
  <script src="https://libraries.ucsd.edu/jwplayer/key.js"></script>
  <meta name="google-site-verification" content="HI6wrYt0meZpVLczcK9LcLuAzgDbqWijEeUPIaR1Oh0" />
  <%= render :partial => 'layouts/googleanalytics'%>
  <%= csrf_meta_tags %>

</head>

app/views/shared/_header.html.erb
<section class="container-fluid ucsd-head">
  <a class="pull-right ucsd-head-logo" href="http://www.ucsd.edu">
    <%=image_tag "logo-ucsd-header.png", :alt => 'UC San Diego' %>
  </a>
  <a class="brand" href="<%= root_path%>">Digital Media Reserves (DMR)</a>
</section>

app/views/shared/_menu.html.erb
<nav class="navbar navbar-default">
    <div class="container-fluid">
      <!-- Collect the nav links, forms, and other content for toggling -->
      <div class="collapse navbar-collapse" id="bs-example-navbar-collapse-1">
        <ul class="nav navbar-nav">
          <li><a href="<%= root_path%>">Home</a></li>
          <li class="dropdown">
            <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">Audio <span class="caret"></span></a>
            <ul class="dropdown-menu">
              <li><%= link_to "Create New Audio Record", new_audio_path, 'data-no-turbolink' => true %></li>
              <li role="separator" class="divider"></li>
              <li><a href="<%= audios_path%>">View Last 10 Audio Records</a></li>
            </ul>
          </li>
          <li class="dropdown">
            <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">Video <span class="caret"></span></a>
            <ul class="dropdown-menu">
              <li><%= link_to "Create New Video Record", new_medium_path, 'data-no-turbolink' => true %></li>
              <li role="separator" class="divider"></li>
              <li><a href="<%= media_path%>">View Last 10 Video Records</a></li>
            </ul>
          </li>
        </ul>
        <ul class="nav navbar-nav">
          <li class="dropdown">
            <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">Course Reserve List <span class="caret"></span></a>
            <ul class="dropdown-menu">
   			  <li><%= link_to "Create New Course Reserve List", new_course_path, 'data-no-turbolink' => true %></li>             
              <li role="separator" class="divider"></li>
              <% if (session[:current_course] != nil)%>
                <li><a href="<%= edit_course_path(session[:current_course].to_s)%>" data-no-turbolink="true">View Current Course Reserve List</a></li>              
                <li role="separator" class="divider"></li>
              <% end %>
              <li><a href="<%= courses_path%>">View Last 10 Course Reserve List</a></li>
            </ul>
          </li>
          <li><%= link_to "Archive", lookup_courses_path, 'data-no-turbolink' => true %></li>
          <li><a href="https://lisn.ucsd.edu/display/DRG/DMR+Archive+Working+Policy">Procedures and Policy</a></li>
          <li class="dropdown">
            <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">Stats<span class="caret"></span></a>
            <ul class="dropdown-menu">
   			  <li><%= link_to "Audio Stats", analytics_path(:type => 'audio'), 'data-no-turbolink' => true %></li>             
              <li role="separator" class="divider"></li>
              <li><%= link_to "Video Stats", analytics_path, 'data-no-turbolink' => true %></li>
              <li role="separator" class="divider"></li>
              <li><%= link_to "Licensed Media Audio Stats", licensed_analytics_path(:type => 'audio'), 'data-no-turbolink' => true %></li>
              <li role="separator" class="divider"></li>
              <li><%= link_to "Licensed Media Video Stats", licensed_analytics_path, 'data-no-turbolink' => true %></li>
            </ul>
          </li>
          <li><%= link_to "Report A Bug", "#{root_url}bug.html", :onclick=>"window.open(this.href,'bug', 'height=750, width=600');return false;" %></li>          
          <li><a href="<%= destroy_user_session_path %>">Sign Out</a></li>
        </ul>
        
        <% if !display_search.nil? && display_search == "true" %>      
          <%= render :partial => 'shared/search_box'%> 
        <% end %>     
      </div><!-- /.navbar-collapse -->
    </div><!-- /.container-fluid -->
</nav>

app/views/shared/_report_footer.html.erb
        <div id="bug_report">
            <button><%= link_to "Playback Issues?", "#{root_url}bug.html", :onclick=>"window.open(this.href,'bug', 'height=750, width=600');return false;" %></button>
        </div>
		<div id="tdr_footer">
			<div id="tdr_footer_content">
				<div id="tdr_address">
					<span id="tdr_address_place">UC San Diego</span>
					<span id="tdr_address_street">9500 Gilman Dr.</span>
					<span id="tdr_address_city_state_zip">La Jolla, CA 92093</span>
					<span id="tdr_address_phone">(858) 534-2230</span>
				</div><!-- /tdr_address -->
				<div id="tdr_copyright">Copyright &copy;2009 Regents of the University of California. All rights reserved.</div>
				<ul id="tdr_footer_links">
					<li id="tdr_footer_t_and_c"><a href="http://www.ucsd.edu/_about/legal/index.html">Terms &amp; Conditions</a></li>
					<li id="tdr_footer_t_and_c"><a href="http://www-act.ucsd.edu/cwp/feedback/tool/libraries" onclick="window.open('http://www-act.ucsd.edu/cwp/feedback/tool/libraries','DYGWYW','menubar=0,resizable=1,scrollbars=1,width=590,height=660');return false;">Feedback</a></li>
					<li id="tdr_footer_feedback"><%= link_to "Report A Bug/Issue", "#{root_url}bug.html", :onclick=>"window.open(this.href,'bug', 'height=750, width=600');return false;" %></li>
				</ul>
			</div><!-- /tdr_footer_content -->
		</div><!-- /tdr_footer -->

app/views/shared/_report_header.html.erb
	<head>
		<meta content="IE=edge,chrome=1" http-equiv="X-UA-Compatible"/>
		<meta charset="UTF-8" />
		<meta content="index,follow,noarchive" name="robots"/>
		<meta content="UC San Diego Libraries" lang="en-US" name="KEYWORDS"/>
		<meta content="UC San Diego Libraries" lang="en-US" name="COPYRIGHT"/>
		<meta content="University of California, San Diego" name="ORGANIZATION"/>
        <meta name="google-site-verification" content="HI6wrYt0meZpVLczcK9LcLuAzgDbqWijEeUPIaR1Oh0" />
		<%= stylesheet_link_tag 'playlist', media: 'all', 'data-turbolinks-track' => true %>
		<title>Digital Media Reserves - The Library</title>
		<link href="//libraries.ucsd.edu/_resources/campus-design-2009/images/common/favicon.gif" rel="icon" type="image/gif"/>
		<link href="//libraries.ucsd.edu/_resources/campus-design-2009/css/campus/identity.css" media="all" rel="stylesheet" type="text/css"/>
		<link href="//libraries.ucsd.edu/_resources/campus-design-2009/css/campus/print.css" media="print" rel="stylesheet" type="text/css"/>
		<link href="//libraries.ucsd.edu/_resources/campus-design-2009/css/libraries.css" media="all" rel="stylesheet" type="text/css"/>
		<script type="text/javascript" src="/assets/draw-menu.js"></script>
		
		<!--JWPlayer-->
		<script type="text/javascript" src="https://content.jwplatform.com/libraries/uS59kPRL.js" ></script>
		<script type="text/javascript" src="https://libraries.ucsd.edu/jwplayer/key.js" ></script>
		<%= render :partial => 'layouts/googleanalytics'%>
		
	</head>

app/views/shared/_report_menu.html.erb
<div id="tdr_title">
			<div id="tdr_title_content">
				<div id="tdr_title_ucsd_title"><a href="http://www.ucsd.edu/">UC San Diego</a></div>
				<div id="tdr_title_page_title"><a href="http://libraries.ucsd.edu/index.html">The Library</a></div>
			</div><!-- /tdr_title_content -->
		</div><!-- /tdr_title -->
		
		<div id="tdr_nav">
			<div id="tdr_nav_content">
				<script>
					draw_ucsd_menu(top_nav,"tdr_nav_list");
				</script>
				<noscript>
					<ul id="tdr_nav_list">
						<li><a href="http://libraries.ucsd.edu/">Home</a></li>
						<li><a href="http://libraries.ucsd.edu/locations">Libraries</a></li>
						<li><a href="http://libraries.ucsd.edu/hours">Hours</a></li>
						<li><a href="http://libraries.ucsd.edu/tools">Research Tools</a></li>
						<li><a href="http://libraries.ucsd.edu/collections">Collections</a></li>
						<li><a href="http://libraries.ucsd.edu/services">Services</a></li>
						<li><a href="http://libraries.ucsd.edu/resources/course-reserves">Reserves</a></li>
						<li><a href="http://roger.ucsd.edu/">Catalogs</a></li>
						<li><a href="http://roger.ucsd.edu/patroninfo">My Library Account</a></li>
						<li><a href="http://libraries.ucsd.edu/help/ask-a-librarian">Ask a Librarian</a></li>
						<li><a href="http://libraries.ucsd.edu/help">Help</a></li>
					</ul>
				</noscript>
			</div><!-- /tdr_nav_content -->
		</div><!-- /tdr_nav -->
		
		<div id="tdr_search">
			<div id="tdr_search_content">
				<form action="http://www-act.ucsd.edu/cwp/tools/search-redir" method="get">
					<fieldset>
						<legend>Site Search</legend>
						<label for="search-scope">Search</label>
						<select id="search-scope" name="search-scope">
							<option id="this-site" selected="selected" value="cascade-lib">This Site</option>
							<option id="search-ucsd" value="default_collection">All UCSD Sites</option>
							<option id="search-people" value="faculty-staff">Faculty/Staff</option>
							<option id="search-students" value="students">Students</option>
						</select>
						<label class="hide-label" for="search-term">search term</label>
						<input name="search-term" id="search-term" size="20" type="text"/>
						<button type="submit">Search!</button>
					</fieldset>
				</form>
			</div><!-- /tdr_search_content -->
		</div><!-- /tdr_search -->
			<div id="tdr_crumbs">
		<div id="tdr_crumbs_content">
		  <% if @course %>
			<ul>
				<li><a href="http://libraries.ucsd.edu/index.html">Home</a></li>				
				<li>Digital Media Reserves - <%= @course.course + " " + @course.quarter + " " + @course.year %></li>				
			</ul>
		  <% end %>
		</div><!-- /tdr_crumbs_content -->
	</div><!-- /tdr_crumbs -->

app/views/shared/_search_box.html.erb
<%= form_tag search_media_path, method: "GET", class: "navbar-form navbar-right", role: "search" do%>
  <fieldset>
    <%= label_tag 'search', 'search', class: "hide-label"%>
    <%= text_field_tag :search, params[:search], placeholder: "Search Video, Audio or Course ...", size: 30%>
    <%= submit_tag "", name: nil, class: "btn btn-primary btn-search" %>    
    <%= render :partial => 'shared/search_option'%>
  </fieldset>
<% end %>

app/views/shared/_search_option.html.erb
<% if session[:search_option] && session[:search_option].include?("courses") %>
  <fieldset>
    <legend class="hide-label">Type</legend>
    <label class="radio-inline">
      <input type="radio" name="search_option" value="media">Video
    </label>
    <label class="radio-inline">
      <input type="radio" name="search_option" value="audio">Audio
    </label>
    <label class="radio-inline">
      <input type="radio" name="search_option"  value="courses" checked="checked">Courses
    </label>
  </fieldset>
<% elsif session[:search_option] && session[:search_option].include?("audio") %>
  <fieldset>
    <legend class="hide-label">Type</legend>
    <label class="radio-inline">
      <input type="radio" name="search_option" value="media">Video
    </label>
    <label class="radio-inline">
      <input type="radio" name="search_option" value="audio" checked="checked">Audio
    </label>
    <label class="radio-inline">
      <input type="radio" name="search_option"  value="courses">Courses
    </label>
  </fieldset>                 
<% else %>
  <fieldset>
    <legend class="hide-label">Type</legend>
    <label class="radio-inline">
      <input type="radio" name="search_option" value="media" checked="checked">Video
    </label>
    <label class="radio-inline">
      <input type="radio" name="search_option" value="audio">Audio
    </label>
    <label class="radio-inline">
      <input type="radio" name="search_option"  value="courses">Courses
    </label>
  </fieldset>
<% end %>

app/views/shared/_thumbnail.html.erb
<div class="col-xs-3 col-sm-3">
  <% if obj.file_name.include?('.mp3') %>
    <% thumbnailURL = "#{Rails.configuration.audio_file_path}#{obj.file_name.gsub('.mp3','.jpg')}"%>
    <% if url_exist?(thumbnailURL) %>
      <%=image_tag "#{thumbnailURL}", :alt => '', :class => 'media-thumbnail' %>
    <% else %>
       <%=image_tag "speaker.gif", :alt => '', :class => 'media-thumbnail' %>
    <% end %>  
  <% else %>
    <%=image_tag "/media/#{obj.id}/#{obj.file_name.gsub('.mp4','.jpg')}", :alt => '', :class => 'media-thumbnail' %>
  <% end %>
</div>